Module class_TensorProductGrid  
 use class_CoordinateMap
 implicit none
 public  :: NewTensorProductGrid
 public  :: DeleteTensorProductGrid
 
 type TensorProductGrid  
  integer                    :: DataDims(3)   !! npts along each coord. axis
  type( CoordinateMap )      :: SpaceDims(3)  !! triplet of coordinate maps 
 end type TensorProductGrid
 
Contains           
 
 subroutine NewTensorProductGrid(CoordMaps,Grid)
  use class_CoordinateMap
  implicit none 
  type( CoordinateMap ),       intent(in)  :: CoordMaps(3)
  type( TensorProductGrid ),intent(inout)  :: Grid
  
  Grid%SpaceDims(1) = CoordMaps(1)
  Grid%SpaceDims(2) = CoordMaps(2)
  Grid%SpaceDims(3) = CoordMaps(3)
  
  Grid%DataDims(1)  = CoordMaps(1)%npts 
  Grid%DataDims(2)  = CoordMaps(2)%npts
  Grid%DataDims(3)  = CoordMaps(3)%npts
 end subroutine NewTensorProductGrid


 
 subroutine DeleteTensorProductGrid(Grid)
  use class_CoordinateMap
  implicit none      
  type( TensorProductGrid ),intent(inout)  :: Grid
  
  call DeleteCoordinateMap( Grid%SpaceDims(1) )
  call DeleteCoordinateMap( Grid%SpaceDims(2) )
  call DeleteCoordinateMap( Grid%SpaceDims(3) )
 end subroutine DeleteTensorProductGrid



end Module class_TensorProductGrid  !======================================
