subroutine set_rhs_for_pressure
#define DEBUG_LEVEL 1

use mpi_parameters
use grid_info
use intermediate_variables
use counters_flags_etc
use boundary_information
use immersed_boundary
implicit none
include '../input/problem_size.h'
include 'mpif.h'

#if DEBUG_LEVEL >= 1
      if(myid == 0 ) write(0,*) 'hello world from set_rhs_for_pressure'
#endif


!Set the entire rhs array b
  if( psolve_scheme .eq. 'total_pressure' ) then
   b(:,:,:) = div_u(:,:,:,new)/dt
  elseif( psolve_scheme .eq. 'change_in_pressure' ) then
   b(:,:,:)=(div_u(:,:,:,new)-div_u(:,:,:,old))/dt
  endif

! if both x & y directions are periodic, we solve for pressure in
! the [kx,ky] wavenumber domain.
 if( boundary_type2(1,1)=='periodic' .and.  boundary_type4(1,1)=='periodic' ) then
  call xy_fft(b,b,nx,ny,locnz,1)   ! 1--> forward transform
  return
 endif

!For all Neumann conditions, with BCs  imposed on u_star
!the compatability condition is that the mean value of b be zero

!**************************************************************
!********** CHECK FOR DIRICHLET CONDITIONS ON 6 BOUNDARIES ****
!**************************************************************

  if( BC_pressure1(1,1) .eq. 'Dirichlet' ) then
   b(1,:,:)=0.0  ! homogeneous
  endif
  if( BC_pressure2(1,1) .eq. 'Dirichlet' ) then
   b(nx,:,:)=0.0  ! homogeneous
  endif
  if( BC_pressure3(1,1) .eq. 'Dirichlet' ) then
   b(:,1,:)=0.0  ! homogeneous
  endif
  if( BC_pressure4(1,1) .eq. 'Dirichlet' ) then
   b(:,ny,:)=0.0  ! homogeneous
  endif
  if( myid==0 .and. BC_pressure5(1,1) .eq. 'Dirichlet' ) then
   b(:,:,1)=0.0  ! homogeneous
  endif
  if( myid==numprocs-1 .and. BC_pressure6(1,1) .eq. 'Dirichlet' ) then
   b(:,:,locnz)=0.0  ! homogeneous
  endif

end subroutine set_rhs_for_pressure
