##############################################
#   Make.inc
##############################################

SHELL=/bin/sh
#
NETCDF_INC = /usr/local/pub/include
NETCDF_LIB = $(NETCDF)
FFTW_INC = /usr/local/pub/FFTW/fftw-2.1.5/include 
FFTW_LIB = -L/usr/local/pub/FFTW/fftw-2.1.5/lib -lsfftw -lsrfftw -lsfftw_threads -lsfftw_mpi -lsrfftw_mpi -lm
BLAS_LIB = $(BLAS_I4S4D8)
LAPACK_LIB = $(LAPACK_I4S4D8)
LIBS= $(FFTW_LIB) $(NETCDF_LIB) $(LAPACK_LIB)

# f90 compiler:
f90=mpxlf_r
f90_DEBUG_FLAGS= -g -C -qinitauto -qfloat=nans -qsigtrap   ### -qnooptimize -qflttrap=overflow:underflow:zerodivide:invalide:enable 
f90F_FLAGS= -I$(NETCDF_INC) -I$(FFTW_INC)  -qfree -qsuffix=f=f90 -qsuffix=cpp=f90 
#f90O_FLAGS= -pg -c $(f90F_FLAGS)
f90O_FLAGS= -c $(f90F_FLAGS) $(f90_DEBUG_FLAGS)

# c and preprocessor flags
CFLAGS= -O2 
CPPFLAGS=
FPPFLAGS=

##############################################
