subroutine set_diffusion

! routine to set the diffusivity profiles, Km_of_z and Kt_of_z

use grid_info
use user_parameters       ! for Km_of_z and Kt_of_z
use dependent_variables   
use dimensional_scales    
use counters_flags_etc
use mpi_parameters
implicit none
include '../input/problem_size.h'

! local variables
 real        :: zpos,diff
 real        :: diffd
!!! real, dimension(locnz)  :: zz

 do k=1,locnz
!   zpos = Grid(0)%z(1,k)*L_scale     ! [m]
!   diff = diffd(zpos)
!   Km_of_z(k) = diff
!   Kt_of_z(k) = diff
!!!   zz(k) = zpos
   Km_of_z(k) = nu
   Kt_of_z(k) = nu
 enddo
!!!      write(0,'(A4,I2.2,2F10.5)') (('PROF',myid,zz(k),Km_of_z(k)),k=1,locnz)
 return
end subroutine set_diffusion
!
!  DIFFD
!  FUNCTION TO GET INTERPOLATED VALUE OF DIFF FROM GRIDDED DATA
!
      REAL FUNCTION DIFFD(ZK)
!
      PARAMETER(ND=14)
!
      REAL ZK
!
      REAL ZD(ND),DD(ND)
!
      DATA IZTOPD/ND/
!
!!! xlv  Km_of_z/Kt_of_z : pas assez de profondeur
!!!      DATA ZD/0.,20.,25.,30.,35.,40.,43.,43.7,54.1,60./
!!!      DATA DD/.00001,.00001,.00001,.0004,.0010,.0018,.0023,.0118,.0227,.0227/

       DATA ZD/0.,20.,25.,30.,35.,40.,43.,43.7,54.1,60.,100.,200.,500.,1000./
       DATA DD/1.e-6,8.e-6,1.e-5,.00004,.00006,.00008,.0001,.0004,.0010,.0018,.0023,.0118,.0227,.0227/
!
      DIFFD = FK(ZK,ZD,DD,ND,IZTOPD)
!
      RETURN
      END
