      subroutine noise(unoise,vnoise)
!
      use mpi_parameters
      use dependent_variables
      include '../input/problem_size.h'
!
      real      ::      unoise(nx,ny,locnz)
      real      ::      vnoise(nx,ny,locnz)
      double precision      ::      phasex(nx),phasey(ny)
      real                  ::      maxu,minu,maxv,minv
      real                  ::      u0,v0,r
      integer   ::      k,j,i,iseed,nxm1,nym1
!
      nxm1 = nx - 1
      nym1 = ny - 1
!
      u0 = .01
      v0 = .01
      iseed = myid - 16
!
      do j=1,ny
      r = ran1(iseed)
      r = -1. + 2.*r
      phasey(j) = r
      enddo
!
      do i=1,nx
      r = ran1(iseed)
      r = -1. + 2.*r
      phasex(i) = r
      enddo
!
!!!      write(0,*) 'PHASEX',myid,phasex
!!!      write(0,*) 'PHASEY',myid,phasey
!
       do k=1,locnz
!
          do i=1,nxm1
             unoise(i,:,k) = u0*phasey(:)
             unoise(i,ny,k) = unoise(i,1,k)
          enddo
          unoise(nx,:,k) = unoise(1,:,k)
!
          do j=1,nym1
             vnoise(:,j,k) = v0*phasex(:)
             vnoise(nx,j,k) = vnoise(1,j,k)
          enddo
          vnoise(:,ny,k) = vnoise(:,1,k)
!
      maxu = MAXVAL(unoise(:,:,k))
      minu = MINVAL(unoise(:,:,k))
      maxv = MAXVAL(vnoise(:,:,k))
      minv = MINVAL(vnoise(:,:,k))
      write(0,*) 'MAXMIN',myid,k,maxu,minu,maxv,minv
!
       enddo
!
       end
!
      FUNCTION ran1(idum)
      INTEGER  ::   idum,IA,IM,IQ,IR,NTAB,NDIV
      REAL  ::   ran1,AM,EPS,RNMX
      PARAMETER (IA=16807,IM=2147483647,AM=1./IM,IQ=127773,IR=2836,   &
      NTAB=32,NDIV=1+(IM-1)/NTAB,EPS=1.2e-7,RNMX=1.-EPS)
      INTEGER  ::   j,k,iv(NTAB),iy
      SAVE  ::   iv,iy
      DATA iv /NTAB*0/, iy /0/
      if (idum.le.0.or.iy.eq.0) then
        idum=max(-idum,1)
        do  j=NTAB+8,1,-1
          k=idum/IQ
          idum=IA*(idum-k*IQ)-IR*k
          if (idum.lt.0) idum=idum+IM
          if (j.le.NTAB) iv(j)=idum
      enddo
        iy=iv(1)
      endif
      k=idum/IQ
      idum=IA*(idum-k*IQ)-IR*k
      if (idum.lt.0) idum=idum+IM
      j=1+iy/NDIV
      iy=iv(j)
      iv(j)=idum
      ran1=min(AM*iy,RNMX)
      return
      END
