subroutine set_BC_values
#define DEBUG_LEVEL 1

! ****  Most arrays available via use statements ******
 use grid_info
 use boundary_information
 use dependent_variables
 use pde_parameters
 use dimensional_scales
 use mpi_parameters
 use counters_flags_etc
 use user_parameters
 implicit none
!******************************************************
 include '../input/problem_size.h'
 include 'mpif.h'
!******************************************************
 real dv_dzeta,f_of_t

 if( istep > istart .and. steady_BCS=='yes' ) return
#if DEBUG_LEVEL >= 1
 if(myid==0) write(0,*) 'hello world from set_BC_values'
#endif

! FACE 1:  xi=0
 BC_values1(:,:,1)=0.0    ! BC_vel1(:,:)='solid' => U
 BC_values1(:,:,2)=0.0    ! BC_vel1(:,:)='specified_value' => v
 BC_values1(:,:,3)=0.0    ! BC_vel1(:,:)='specified_value' => W
 BC_values1(:,:,4)=0.0    ! BC_scalar1(:,:,1)='specified_gradient' => d/dxi (s1)
 if(num_scalars>1)  &
 BC_values1(:,:,5)=0.0    ! BC_scalar1(:,:,2)='specified_gradient' => d/dxi (s2)

! FACE 2:  xi=1
 BC_values2(:,:,1)=0.0    ! BC_vel1(:,:)='solid' => U
 BC_values2(:,:,2)=0.0    ! BC_vel1(:,:)='specified_value' => v
 BC_values2(:,:,3)=0.0    ! BC_vel1(:,:)='specified_value' => W
 BC_values2(:,:,4)=0.0    ! BC_scalar1(:,:,1)='specified_gradient' => d/dxi (s1)
 if(num_scalars>1)  &
 BC_values2(:,:,5)=0.0    ! BC_scalar1(:,:,2)='specified_gradient' => d/dxi (s2)

! FACE 3:  eta=0
 BC_values3(:,:,1)=0.0    ! BC_vel3(:,:)='specified "stress"' => du/deta
 BC_values3(:,:,2)=0.0    ! BC_vel3(:,:)='specified "stress"' => "dv/deta"
 BC_values3(:,:,3)=0.0    ! BC_vel3(:,:)='specified "stress"' => dw/deta
 BC_values3(:,:,4)=0.0    ! BC_scalar3(:,:,1)='specified_gradient' => ds1/deta
 if(num_scalars>1)  &
 BC_values3(:,:,5)=0.0    ! BC_scalar3(:,:,2)='specified_gradient' => ds2/deta

! FACE 4:  eta=1
 BC_values4(:,:,1)=0.0    ! BC_vel4(:,:)='specified "stress"' => du/deta
 BC_values4(:,:,2)=0.0    ! BC_vel4(:,:)='specified "stress"' => "dv/deta"
 BC_values4(:,:,3)=0.0    ! BC_vel3(:,:)='specified "stress"' => dw/deta
 BC_values4(:,:,4)=0.0    ! BC_scalar4(:,:,1)='specified_gradient' => ds1/deta
 if(num_scalars>1)  &
 BC_values4(:,:,5)=0.0    ! BC_scalar4(:,:,2)='specified_gradient' => ds2/deta

! FACE 5:  zeta=0   ! values set for free-slip wall
if( myid == 0 ) then
 BC_values5(:,:,1)=0.0    ! BC_vel5(:,:)='specified_stress' => dU/dzeta=0
 BC_values5(:,:,2)=0.0    ! BC_vel5(:,:)='specified_stress' => dv/dzeta=0
 BC_values5(:,:,3)=0.0    ! BC_vel5(:,:)='specified_value' => W=0
 do j=1,ny
! BC_values5(:,j,4)=-s1_bar_zeta(:,1)     ! BC_scalar5(:,:,1)='specified_gradient' => d/dzeta( s1 )
! BC_values5(:,j,4)=0.0                   ! s1=0 IW test
  BC_values5(:,j,4)=0.0                   ! d/dzeta( s1 )=0, total gradient=ambient value
  if(num_scalars>1)  &
  BC_values5(:,j,5)=0.0                   ! d/dzeta( s2 )=0, total gradient=ambient value
 enddo
endif

! FACE 6:  zeta=1
if( myid == numprocs-1 ) then
 BC_values6(:,:,1)=0.0    ! BC_vel6(:,:)='specified_stress' => set dU/dzeta=0
 BC_values6(:,:,2)=0.0    ! BC_vel6(:,:)='specified_stress' => set dV/dzeta=0
 BC_values6(:,:,3)=0.0    ! solid => W=0
 do j=1,ny
  BC_values6(:,j,4)=-s1_bar_zeta(:,locnz)    ! BC_scalar6(:,:,1)='specified_gradient' => d/dzeta( s1 )
  if(num_scalars>1)  &
  BC_values6(:,j,5)=-s2_bar_zeta(:,locnz)    ! BC_scalar6(:,:,2)='specified_gradient' => d/dzeta( s2 )
 enddo

endif

end subroutine set_BC_values
