! Ce fichier est un fichier d'en tte utilis par le preprocesseur C et qui permet de definir des
! parametres utilises lors la phase de compilation ( la difference du fichier data.in qui lui
! contient des parametres utilises lors de l'execution du code).

! Pour chaque variable, la syntaxe a utiliser est la suivante (les commandes doivent tre imprativement
! places en debut de ligne) :
! "#undef nom_balise" : la variable n'est pas definie. La fonction associee est desactivee.
! "#define nom_balise" : la variable est definie. La fonction associee est activee.
! "#define nom_balise valeur" : la variable vaut la valeur "valeur".


! Dimensions du problemes. Attention en fonction de la librairie de FFT utilisee certaines valeurs sont interdites
! et d'autres conseillees.
! Pour la librairie FFTW, les produits des facteurs premiers 2,3, 5, et 7 fonctionnent bien et tout particulirement
! les puissances de 2.
#define DIMX 2
#define DIMY 64
#define DIMZ 64

! utile pour definir un mode "debugage" dans le code (pas d'initialisation du generateur de nombre aleatoire,
! affichage de valeurs intermediaires...)
#define debug

! On active ou non le fait de n'appliquer certaines fonctions (adams_step1, adams_step2, projection etc.)
! uniquement sur les termes non affects par la troncature. Peut faire gagner un peu de temps de calcul si
! les termes tronqus sont nombreux. Peut faire perdre du temps s'ils sont peu nombreux ou sur une architecture trs
! vectorielle (le test peut casser la vectorisation). A tester donc...
#undef test_troncature

! active le test de la presence de NaN dans les resultats obtenus. Cela permet ainsi de stopper le calcul si celui-ci
! a diverge.
! Attention la fonction de test utilisee "isnan" ne fait pas partie du standard Fortran 90/95 et n'est donc pas
! supporte par tous les compilateur. Intel Fortran Compiler 8 par exemple accepte cette fonction.
#undef test_isnan

! Valeurs de padding suivant les 3 directions (augmentation artificielle des tailles des tableaux de faon
!  amliorer les acces memoire). Attention, il faut que PPADX soit un nombre pair.
! Normalement il faut adapter ces valeurs en fonction des dimensions physiques nxmax,nymax,nzmax et de
! de l'architecture de calcul (NEC, processeur Intel...).
#define PPADX 0
#define PPADY 0
#define PPADZ 0

! choix de la fonction qui genere l'ecoulement de base. Actuellement est disponible :
! 1 : tourbillons de stuart
! 2 : profil en tanh
! 3 : superposition de vortex gaussiens dont les caracteristiques sont donnees dans le fichier data.in
#define choix_base2D 1

! On calcule ou non une vitesse de translation ut pour determiner un champ de base stationnaire dans un referentiel
! en translation
#undef calcul_ut

! Version du code ou l'on simule un seul mode suivant kz. Attention, une telle simulation n'a des sens que pour une simulation
! lineaire et pour un mode ayant un taux de croissance reel
#undef mode_kz


! ON NE TOUCHE PLUS !
! On fait ici quelques operations que l'on peut faire automatiquement si cela n'a pas ete fait manuellement
#ifdef mode_kz

#define DIMZ 1
#define PPADZ 0

#endif
